<!DOCTYPE html> <!-- indique un doc en HTML5-->
<html>

<head>
	<title>formulaires</title>
	<meta charset="utf-8" /> <!-- aussi par défaut dans HTML5-->
	<link rel="stylesheet" type="text/css" href="../css/Stylesheet.css" />
	<!--va chercher le fichier CSS-->
</head>

<body>
	<Nav>
		<h2 class="navigation flexnav">
			<p><a href="index.html">Balises HTML </a></p>
			<p><a href="TextCSS.html">Mise en forme du texte </a></p>
			<p><a href="Boxmodel.html">Mise en forme des boites </a></p>
			<p><a href="Formulaires.html">Formulaires </a></p>
			<p><a href="JavaScript.html">JavaScript </a></p>
			<p><a href="Illustrations.html">Illustrations </a></p>
		</h2>

	</nav>
	<h1>Les formulaires</h1>
	<p>Ils permettent de recueillir des données envoyées par les utilisateurs. HTML permet de les créer, mais pas de
		traiter les informations recueillis, ni les stocker. On aura besoin pour cela d'un outil comme PHP pour traiter
		les données et d'un autre comme MySQL pour les enregistrer.</p>
	<p>Il faut TOUJOURS sécuriser les formulaires, par exemple avec php.</p>

	<h2>la syntaxe des formulaires</h2>
	<p>L'élément <strong>form</strong> définit un formulaire. Il a besoin de 2 attributs pour fonctionner : <ul>
			<li><strong>method</strong> qui indique comment doivent être envoyées les données saisies par l'utilisateur,
				avec les valeurs <ul>
					<li><strong>get</strong> (faire transiter les données par l'URL afin de pouvoir ensuite les traiter
						= cela limite la quantité de données et ele sont envoyées en clair, donc à éviter si données
						sensibles) ou </li>
					<li><strong>post</strong> (envoyer les données par HTTP post transaction : pas de limites de
						quantité et les données ne sont pas visibles)</li>
				</ul>
			</li>
			<li><strong>action</strong> qui sert à préciser l'adresse relative où les données doivent être traitées
				(souvent un fichier PHP).</li>
		</ul>
		<span class="ex">&lt;form method="post" action ="traitement.php"&gt; ici, on va créer le formulaire
			&lt;/form&gt;</span><br /></p>

	<p>Dans cette balise form, on va créer le formulaire, avec la balise <strong>textarea</strong> ou bien la balise
		<strong>input</strong> ou encore <strong>select</strong>.</p>
	<p class="ex">&lt;form method="post" action ="traitement.php"&gt; &lt;textarea name="reponse"
		id="lab1"&gt;&lt;/textarea&gt;&lt;/form&gt;</p>
	<form method="post" action="traitement.php"><textarea name="reponse" id="lab1"></textarea></form>

	<p>L'élément <strong>label</strong> définit une légende pour un élément input, textarea ou select, afin de décrire à
		l'utilisateur ce qu'il doit rentrer dans le champ. Le label est lié à l'élément de formulaire grâce aux
		attributs "for" (pour le label) et id (pour l'élément) qui doivent être strictement identiques.</p>
	<p class="ex">&lt;form method="post" action ="traitement.php"&gt; &lt;label for="lab1"&gt;Notez ici votre réponse :
		&lt;/label&gt; &lt;textarea name="reponse" id="lab1"&gt;&lt;/textarea&gt;&lt;/form&gt;</p>
	<form method="post" action="traitement.php"> <label for="lab1">Notez ici votre réponse : </label> <textarea
			name="reponse" id="lab1"></textarea></form><br />

	<p>L'attribut <strong>name</strong> permet de donner un nom aux données qui seront recueillies pour pouvoir les
		retrouver.</p>
	<hr />

	<h2>Voici les différentes possibilités avec leur illustrations.</h2>
	<p>L'élément <strong>textarea</strong> définit un champ de texte long, multiligne pour accueillir un commentaire par
		exemple.</p>
	<div class="exemple">
		<form method="post" action="traitement.php">
			<label for="commentaire">Notez ici votre commentaire : </label>
			<textarea name="commmentaire" id="commentaire"></textarea><br />
		</form>
	</div>

	<p>L'élément <strong>button</strong> est proche de l'élément "input". Il peut prendre les attributs <ul>
			<li>"accesskey" qui définit un raccourci clavier simulant le clic, avec les valeurs "touche" et "clavier"
				(ATTENTION, déconseillé pour les sites <a
					href="https://developer.mozilla.org/fr/docs/Web/HTML/Attributs_universels/accesskey"
					target="_blank">web</a>).</li>
			<li>"disabled", qui rend le bouton non cliquable et grisé</li>
			<li>"type" pour définir un événement associé au clic, avec les valeurs "button" (bouton classique), "reset"
				(efface tous les champs renseignés dans le formulaire) et "submit" (valide le formulaire dans lequel il
				est contenu)</li>
		</ul>
	</p>
	<div class="exemple">
		<form method="post" action="traitement.php">
			<label for="rem">Notez ici vos remarques : </label>
			<textarea name="rem" id="rem"></textarea><br />
			<button type="reset">Effacer</button>
			<button disabled="disabled">disabled</button><br />
		</form>
	</div>

	<p>L'élément <strong>input</strong> définit un champ de données pour l'utilisateur. C'est une balise orpheline, avec
		un attribut "type" pour creer un champ de saisie, des zones d'option, un bouton...</p>
	<br />

	L'attribut <strong>type </strong> peut prendre les valeurs :
	<ul>
		<li>type="text" : un champ de saisie monoligne</li>
		<li>type="password" : un champ de saisie sécurisé (ce qui est écrit n'est pas affiché en clair)</li>

		<div class="exemple">
			<form method="post" action="traitement.php">
				<label for="pseudo">Entrer votre pseudo : </label>
				<input type="text" name="pseudo" id="pseudo"><br />
				<label for="password">Entrer votre mot de passe : </label>
				<input type="password" name="password" id="password"></input><br />
				<input type="submit" value="Envoyer">
			</form>
		</div>
		<li>type="date" : selon le navigateur, on verra une liste de date à choisir</li>
		<li>type="number" : ne va accepter que des chiffres, selon le navigateur, une barre de défilement peut
			apparaitre</li>

		<div class="exemple">
			<form method="post" action="traitement.php">
				Quels sont vos chiffres fétiches ?<br />
				<label for="naissance">Votre date de naissance </label>
				<input type="date" name="naissance" id="naissance"><br />
				<label for="chiffre">Votre chiffre préféré </label>
				<input type="number" name="chiffre" id="chiffre"><br />
			</form>
		</div>

		<li>type="email" : certains navigateurs récents vont tester le texte entré et vérifier qu'il a bien le format
			d'un email</li>
		<li>type="url" : certains navigateurs récents vont tester le texte entré et vérifier qu'il a bien le format d'un
			url</li>

		<div class="exemple">
			<form method="post" action="traitement.php">
				Notez ici vos liens<br />
				<label for="mail">Votre email </label>
				<input type="email" name="mail" id="mail"><br />
				<label for="site">Votre site</label>
				<input type="url" name="site" id="site"><br />
			</form>
		</div>

		<li>type="radio" : demander de choisir une seule option dans une liste de choix proposés</li>

		<div class="exemple">
			<form method="post" action="traitement.php">
				Homme ou femme ?<br />
				<input type="radio" name="sexe" value="homme" id="homme">
				<label for="homme">Un homme </label><br />
				<input type="radio" name="sexe" value="femme" id="femme">
				<label for="femme">Une femme </label><br /><br />
				Majeur ou mineur ?<br />
				<input type="radio" name="age" value="majeur" id="majeur">
				<label for="majeu">Majeur </label><br />
				<input type="radio" name="age" value="mineur" id="mineur">
				<label for="mineur">Mineur </label><br />
			</form>
		</div>

		<li>type="checkbox" : demander de choisir une ou plusieurs options (ou aucune) dans une liste de choix proposés
		</li>

		<div class="exemple">
			<form method="post" action="traitement.php">
				Quels sports pratiquez-vous ?<br />
				<input type="checkbox" name="sport" value="natation" id="natation">
				<label for="natation">La natation </label><br />
				<input type="checkbox" name="sport" value="golf" id="golf">
				<label for="golf">Le golf </label><br />
				<input type="checkbox" name="sport" value="tennis" id="tennis">
				<label for="tennis">Le tennis </label><br />
				<input type="checkbox" name="sport" value="jogging" id="jogging">
				<label for="jogging">Le jogging </label><br />
			</form>
		</div>

		<li>type="submit" : créer un bouton d'envoi des données. Pas besoin de l'attribut "names" et l'attribut "value"
			permet de donner un nom au bouton</li>
		<div class="exemple">
			<form method="post" action="traitement.php">
				<input type="submit" value="Envoyer">
	</ul>
	</p>

	<p>L'élement <strong>select</strong> définit une liste de choix possibles, avec l'élément "option" (obligatoire) et
		l'élément "optgroup".</p>
	<p>L'élément <strong>option</strong> définit une option dans une liste.</p>
	<p>L'élément <strong>optgroup</strong> définit un groupe d'options dans une liste (permet de regrouper les options).
	</p>

	<div class="exemple">
		<form method="post" action="traitement.php">
			Où habitez-vous ? <br />
			<select name="pays">
				<optgroup label="Europe">
					<option value="france">France</option>
					<option value="belgique">Belgique</option>
				</optgroup>
				<optgroup label="Asie">
					<option value="chine">Chine</option>
					<option value="vietnam">Vietnam</option>
					<option value="Japon">Japon</option>
				</optgroup>
				<optgroup label="Afrique">
					<option value="maroc">Maroc</option>
					<option value="algerie">Algérie</option>
				</optgroup>
			</select>
		</form>
	</div>

	<p>L'élément <strong>fieldset</strong> permet de regrouper des éléments d'un formulaire pour le structurer en créant
		différentes sections.</p>
	<p>L'élément <strong>legend</strong> ajoute une légende à un élément fieldset.</p>

	<div class="exemple">
		<form method="post" action="traitement.php">

			<fieldset>
				<legend>Informations personnelles</legend>
				<label for="nom">Votre nom : </label>
				<input type="text" name="nom" id="nom"><br /><br />
				<label for="prenom">Votre prénom : </label>
				<input type="text" name="prenom" id="prenom"><br /><br />
				<label for="projet">Votre projet : </label>
				<textarea name="projet" id="projet"></textarea><br />
			</fieldset>
			<fieldset>
				<legend>Informations complémentaires</legend>
				Quelles sont vos activités préférées ?<br />
				<input type="checkbox" name="musique" value="musique" id="musique">
				<label for="musique">La musique </label>
				<input type="checkbox" name="danse" value="danse" id="danse">
				<label for="danse">La danse </label>
				<input type="checkbox" name="sport1" value="sport1" id="sport1">
				<label for="sport1">Le sport </label>
				<input type="checkbox" name="shopping" value="shopping" id="shopping">
				<label for="shopping">Le shopping </label><br />
			</fieldset>
			<input type="submit" value="Envoyer">

		</form>
	</div>

	<p>L'élément <strong>isindex</strong> est obsolète.</p>
	<hr />

	<h2>Les éléments HTML5</h2>
	<p>L'élément <strong>menu</strong> regroupe des commandes (boite à outils, barre d'action, menu contextuel...) dont
		les commandes sont des actions déclanchées par l'utilisateur et sont déclarés avec la balise "command". Ses
		attributs sont :<ul>
			<li>"label" avec la valeur "text"</li>
			<li>"type", avec les valeurs "context", "list", "toolbar"</li>
		</ul>
	</p>
	<p>L'élément <strong>command</strong> définit une action réalisable par l'utilisateur. Il se place dans les balises
		"menu". (à développer)</p>


	<p>L'élément <strong>datalist</strong> permet de définir une liste de valeurs associés à un élément "input".</p>
	<p>L'élément <strong>output</strong> est utilisable au sein des formulaires pour afficher le résultat d'un calcul.
		Le champ est en lecture seule. Ci-dessous un exemple de calcul :</p>
	<div class="exemple">
		<form name="calcul" oninput="resultat2.value = valeur3.value*valeur4.value;">
			<input name="valeur3" type="number" value="15"> x
			<input name="valeur4" type="number" value="10">=
			<output for="valeur3 valeur4" name="resultat2" </output> </form> </div> <p>Un autre exemple avec le type
				"range" : </p>
				<div class="exemple">
					<form onsubmit="return false" oninput="resultat.value = echelle.valueAsNumber;">
						<div style="border:solid 1px silver; padding: 5px;">
							<input id="echelle" name="echelle" type="range" min="0" max="10" style="width: 300px;">
							<output id="resultat" for="echelle" style="margin:0px;padding:0px;">5</output>/10
						</div>
					</form>
				</div>

				<p>L'élément <strong>keygen</strong> génère au sein d'un formulaire une paire de clés de sécurité pour
					permettre le cryptage et décryptage des données échangées.(à développer)</p>
				<hr />
				<h2>Les attributs complémentaires</h2>
				<p>L'attribut <strong>autocomplete</strong> permet l'autocomplétion d'un champ. Il finit automatiquement
					le remplissage d'un champ en se basant sur les informations entrées précédemment dans d'autres
					formulaires par l'utilisateur. Il peut prendre 2 valeurs : "on" (le champ s'autocomplète) et "off".
				</p>
				<p>L'attribut <strong>autofocus</strong> force le focus d'un champ. le curseur de la souris est
					automatiquement présente dans le champ à compléter. Sa valeur est "autofocus" (donc pas la peine de
					préciser).</p>
				<p>Les attributs <strong>min</strong> et <strong>max</strong> permettent de définir une valeur minimale
					et maximale pour un champ. Ils sont généralement utilisés avec l'élément "input type="number".</p>
				<p>L'attribut <strong>maxlength</strong> limite le nombre de caractères.</p>
				<p>L'attribut <strong>placeholder</strong> donne des indications sur les données attendues. Il place un
					exemple dans le champ, sous forme de valeur grise à moitié transparente, qui disparait dès que
					l'utilisateur clique dans le champ.</p>
				<p>L'attribut <strong>checked</strong> pré-coche une case.</p>
				<p>L'attribut <strong>selected</strong> pré-sélectionne une option dans une liste.</p>
				<p>L'attribut <strong>required</strong> force le remplissage d'un champ. Le formulaire ne pourra pas
					être envoyé sans le remplissage. ATTENTION, n'est pas supporté par les vieilles versions d'internet
					explorer, ni par safari.</p>

				<div class="exemple">
					<form method="post" action="traitement.php">
						<fieldset>
							<legend>Informations personnelles</legend>
							<label for="nom1">Votre nom : </label>
							<input type="text" name="nom1" id="nom1" autofocus><br />
							<label for="nom2">Votre surnom : </label>
							<input type="text" name="nom2" id="nom2" placeholder="Ex : Kiki"><br />
							<label for="nom3">Votre pseudo (8 caractères maximum) : </label>
							<input type="text" name="nom3" id="nom3" size="10" maxlenght="8"><br />
							<!--maxlenght et size ne marchent pas-->
							<label for="prenom">Votre prénom : </label>
							<input type="text" name="prenom" id="prenom" autocomplete="on"><br />
							<label for="age1">Votre âge : </label>
							<input type="number" name="age1" id="age1" min="1" max="120"><br />
							<!--ca met le champ en rouge, mais l'échelle ne marche plus-->
							<label for="tel">Votre numéro de téléphone* : </label>
							<input type="text" name="tel" id="tel" required><br />
							<input type="checkbox" name="accord" value="accord" id="accord" checked></input>
							<label for="accord">j'accepte de recevoir des pub pourries </label><br />
						</fieldset>
						<fieldset>
							<legend>Informations complémentaires</legend>
							Quelles sont vos activités préférées ?<br />
							<input type="checkbox" name="musique" value="musique" id="musique">
							<label for="musique">La musique </label>
							<input type="checkbox" name="danse" value="danse" id="danse">
							<label for="danse">La danse </label>
							<input type="checkbox" name="sport1" value="sport1" id="sport1" checked>
							<label for="sport1">Le sport </label>
							<input type="checkbox" name="shoping" value="shopping" id="shopping">
							<label for="shopping">Le shopping </label><br /><br />
							Où habitez-vous ?
							<select name="pays">
								<optgroup label="Europe">
									<option value="france">France</option>
									<option value="belgique" selected>Belgique</option>
									<!--selected ne marche pas-->
								</optgroup>
								<optgroup label="Asie">
									<option value="chine">Chine</option>
									<option value="vietnam">Vietnam</option>
									<option value="Japon">Japon</option>
								</optgroup>
								<optgroup label="Afrique">
									<option value="maroc">Maroc</option>
									<option value="algerie">Algérie</option>
								</optgroup>
							</select><br /> <br />
							<label for="fruit">Etes vous plutôt "pomme" ou "banane" ? </label>
							<input type="text" name="fruit" id="fruit" required pattern="banane|pomme">
						</fieldset>
						<p><small>* champ obligatoire</small></p>
						<input type="submit" value="Envoyer">
					</form>
				</div>
				<hr />
				<h2>La mise en forme d'un formulaire avec CSS</h2>
				<p>Elle se fait de la même manière que sur d'autres balises (voir le fichier CSS).</p>
				<div class="exemple2">
					<form method="post" action="traitement.php">
						<fieldset id="partie1">
							<legend>Informations personnelles</legend>
							<label for="nom">Votre nom : </label>
							<input type="text" name="nom" id="nom"><br /><br />
							<label for="prenom">Votre prénom : </label>
							<input type="text" name="prenom" id="prenom"><br /><br />
							<label for="projet">Votre projet : </label>
							<textarea name="projet" id="projet"></textarea><br />
						</fieldset>
						<fieldset id="partie2">
							<legend>Informations complémentaires</legend>
							Quelles sont vos activités préférées ?<br />
							<input type="checkbox" name="musique" value="musique" id="musique">
							<label for="musique">La musique </label>
							<input type="checkbox" name="danse" value="danse" id="danse">
							<label for="danse">La danse </label>
							<input type="checkbox" name="sport1" value="sport1" id="sport1">
							<label for="sport1">Le sport </label>
							<input type="checkbox" name="shoping" value="shoping" id="shoping">
							<label for="shoping">Le shoping </label><br />
						</fieldset>
						<input type="submit" value="Envoyer"> <br /><br />
					</form>
				</div>
				<hr />
				<h2>La validation JavaScript des formulaires</h2>
				<p>Le JS peut effectuer des vérifications avant l'envoi des données sur le serveur pour avertir les
					utilisateurs bienveillants d'un oubli ou d'une erreur. Il faut également effectuer des vérifications
					coté serveur (en PHP par exemple) car l'utilisateur peut désactiver le JS sur son navigateur.</p>
				<div class="exemple2">
					<form method="post" action="traitement.php">
						<fieldset id="partie1">
							<legend>Informations personnelles</legend>
							<label for="nom">Votre nom : </label>
							<input type="text" name="nom" id="nom"><br />

							<label for="prenom1">Votre prénom : </label>
							<input type="text" name="prenom" id="prenom1" maxlength="20" required>
							<span id="missPrenom"></span><br />

							<label for="telephone">Votre téléphone : </label>
							<input type="number" name="telephone" id="telephone"></input><br />
						</fieldset>

						<fieldset id="partie2">
							<label for="fruit">Etes vous plutôt "pomme" ou "banane" ? </label>
							<input type="text" name="fruit" id="fruit" required pattern="banane|pomme">
							<legend>Questionnaire</legend>
						</fieldset>
						<input type="submit" value="Envoyer" id="bouton_envoi"> <br /><br />
					</form>
				</div>
				<script>
					var formValid = document.getElementById("bouton_envoi");
					var prenom = document.getElementById("prenom1");
					var missPrenom = document.getElementById("missPrenom");
					var prenomValid = /^[a-zA-ZéèîïÉÈÎÏ][a-zéèêàçîï]+([-'\s][a-zA-ZéèîïÉÈÎÏ][a-zéèêàçîï]+)?$/;
					formValid.addEventListener("click", validation);

					function validation(event) {
						if (prenom.validity.valueMissing) { //si le champ est vide
							event.preventDefault();
							missPrenom.textContent = "Prénom manquant";
							missPrenom.style.color = "red";

						} else if (prenomValid.test(prenom.value) == false) { //si le format est incorrect
							event.preventDefault();
							missPrenom.textContent = "format incorrect";
							missPrenom.style.color = "orange";
						} else {}
					}
				</script>
				<p>Explication de la <a
						href="https://www.pierre-giraud.com/javascript/cours-complet/javascript-validation-formulaires.php"
						target=_blank>regex</a> (expression regulière = ensemble de chaine de caractères possibles) sur
					le prénom.</p>

				<p>On peut utiliser une API (= Application Programming Interface : construction disponible qui fournit
					une syntaxe plus facile à utiliser) de contraintes de validation. Elle se compose d'un ensemble de
					méthodes et de propriétés disponibles sur chaque élément de formulaire. </p>

				<h3>L'évènement "onsubmit"</h3>
				<p>L'évènement onsubmit sert à valider des formulaires (l'information ne sera pas envoyée si onsubmit
					renvoie "false").</p>
				<form onsubmit="return validate()" method="post">
					Entrez un nombre :<input type="text" name="num1" id="num1" /><br />
					Répétez le nombre :<input type="text" name="num2" id="num2" /><br />
					<input type="submit" value="submit" />
				</form>
				<script>
					function validate() {
						var n1 = document.getElementById("num1");
						var n2 = document.getElementById("num2");
						if (n1.value != "" && n2.value != "") /*si les deux sont pas vides*/ {
							if (n1.value == n2.value) {
								return true;
							}
						}
						alert("les valeurs ne sont pas égales");
						return false;
					}
				</script>
				<hr />
				<h2>Autre moyen d'entrer de l'info</h2>
				<p>avec prompt :
					<br /><span class="ex">&lt;script&gt; var n = prompt("Entrez un nombre","");
						var rep = Math.sqrt(n);
						alert("La racine carré de " + n + " est " + rep); &lt;/script&gt;</span>
					<span class="js">
						<script>
							var n = prompt("Entrez un nombre", "");
							var rep = Math.sqrt(n);
							alert("La racine carré de " + n + " est " + rep);
						</script>
					</span></p>
</body>

</html>